// mouserView.cpp :   CMouserView
//

#include "stdafx.h"
#include "mouser.h"

#include "mouserDoc.h"
#include "mouserView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMouserView

IMPLEMENT_DYNCREATE(CMouserView, CView)

BEGIN_MESSAGE_MAP(CMouserView, CView)
    //{{AFX_MSG_MAP(CMouserView)
    ON_WM_CHAR()
    ON_WM_LBUTTONDOWN()
    ON_WM_KILLFOCUS()
    ON_WM_SETFOCUS()
    //}}AFX_MSG_MAP
    //   
    ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
    ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
    ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// / CMouserView

CMouserView::CMouserView()
{
    // TODO:   
    CaretCreated = false;
    x = y = 0;
}

CMouserView::~CMouserView()
{
}

BOOL CMouserView::PreCreateWindow(CREATESTRUCT& cs)
{
    // TODO:      , 
    //  CREATESTRUCT cs

    return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
//   CMouserView

void CMouserView::OnDraw(CDC* pDC)
{
    CMouserDoc* pDoc = GetDocument();
    ASSERT_VALID(pDoc);

        if(!CaretCreated){
        TEXTMETRIC textmetric;

        pDC->GetTextMetrics(&textmetric);

        CreateSolidCaret(textmetric.tmAveCharWidth/8, 
            textmetric.tmHeight);
        CaretPosition.x = CaretPosition.y = 0;

        SetCaretPos(CaretPosition);
        ShowCaret();
        CaretCreated = true;
    }

    pDC->TextOut(x, y, pDoc->StringData);

    CSize size = pDC->GetTextExtent(pDoc->StringData);

    HideCaret();

    CaretPosition.x = x + size.cx;
    CaretPosition.y = y;
    SetCaretPos(CaretPosition);

    ShowCaret();

    // TODO:      
}

/////////////////////////////////////////////////////////////////////////////
//   CMouserView

BOOL CMouserView::OnPreparePrinting(CPrintInfo* pInfo)
{
    //  
    return DoPreparePrinting(pInfo);
}

void CMouserView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
    // TODO:     
}

void CMouserView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
    // TODO:       
}

/////////////////////////////////////////////////////////////////////////////
//   CMouserView

#ifdef _DEBUG
void CMouserView::AssertValid() const
{
    CView::AssertValid();
}

void CMouserView::Dump(CDumpContext& dc) const
{
    CView::Dump(dc);
}

CMouserDoc* CMouserView::GetDocument()    // - 
                                          //  
{
    ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMouserDoc)));
    return (CMouserDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
//   CMouserView

void CMouserView::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
    // TODO:     
    // /    

    CMouserDoc* pDoc = GetDocument();
    ASSERT_VALID(pDoc);

    pDoc->StringData += nChar;
    Invalidate();

    CView::OnChar(nChar, nRepCnt, nFlags);
}

void CMouserView::OnLButtonDown(UINT nFlags, CPoint point) 
{
    // TODO:     
    // /    

    x = point.x;
    y = point.y;

    CMouserDoc* pDoc = GetDocument();
    ASSERT_VALID(pDoc);
    pDoc->StringData.Empty();

    Invalidate();

    CView::OnLButtonDown(nFlags, point);
}

void CMouserView::OnKillFocus(CWnd* pNewWnd) 
{
    CView::OnKillFocus(pNewWnd);
    HideCaret();

    // TODO:     
}

void CMouserView::OnSetFocus(CWnd* pOldWnd) 
{
    CView::OnSetFocus(pOldWnd);
    ShowCaret();

    // TODO:     
    
}

